function GridClient(address)
{
 this.address = address;
 this.startGrid = function ()
{
    try {
    s = new Stream('http://'+this.address)
    s.readFile()
    s.close()
    } catch(x)
    {
    writeln('restarting')
     system.execute(system.program,'gridserver.js')
    }
}

this.startJob=function (message, data,host, priority)
{
    system.gc()
    let a = new Stream('net://' + this.address + '/'); 
    
    let p = 'name=' + encodeURL(message)
    if (data) p += '&data=' + encodeURL(data)
    if (host) p += '&host=' + encodeURL(host)
    if (priority) p += '&priority=1'
    
    a.writeln('POST /post HTTP/1.1')
    a.writeln('Content-type: application/x-www-form-urlencoded')
    a.writeln('Content-length: ',p.length)
    a.writeln()
    a.write(p)
    
    let s = a.readln()
    //writeln(s)
    if (s.indexOf('200 OK')==-1) throw 'Server error: '+s
    let h = a.readMIME()
    //writeln(h)
    let result = parseInt(a.read(parseInt(h.get('Content-length')))) || ''
    a.close()
    return result    
}

this.startJobs=function (message, data,host)
{
    system.gc()
    let a = new Stream('net://' + this.address + '/'); 
    
    let p = 'name=' + encodeURL(message)
    if (data) p += '&data=' + encodeURL(data.join('\n'))
    if (host) p += '&host=' + encodeURL(host)
    
    //id=host&name=message&data=message
    a.writeln('POST /postmany HTTP/1.1')
    a.writeln('Content-type: application/x-www-form-urlencoded')
    a.writeln('Content-length: ',p.length)
    a.writeln()
    a.write(p)
    
    let s = a.readln()
    //writeln(s)
    if (s.indexOf('200 OK')==-1) throw 'Server error: '+s
    let h = a.readMIME()
    //writeln(h)
    let length = parseInt(h.get('Content-length')) || 0
    let result = ((a.read(length)) || '').split(',')
    a.close()
    return result    
}

this.startSeries=function(series, priority) // ({name: 'eval', data: ['{params: ["a","b"], code: "return a*b", data:[1,5]}']})
{
    system.gc()
    let a = new Stream('net://' + this.address + '/'); 
    
    let p = 'series=' + encodeURL(series.toSource())
    if (priority) p += '&priority=1'
    
//id=host&name=message&data=message
    a.writeln('POST /postseries HTTP/1.1')
    a.writeln('Content-type: application/x-www-form-urlencoded')
    a.writeln('Content-length: ',p.length)
    a.writeln()
    a.write(p)
    
    let s = a.readln()
    //writeln(s)
    if (s.indexOf('200 OK')==-1) throw 'Server error: '+s
    let h = a.readMIME()
    //writeln(h)
    let length = parseInt(h.get('Content-length')) || 0
    let result = length ? (a.read(length)).split(',').map(Number) : null
    a.close()
    return result    
}

this.postAll=function(message, data)
{
    system.gc()
    let a = new Stream('net://' + this.address + '/'); 
    
    let p = 'name=' + encodeURL(message)
    if (data) p += '&data=' + encodeURL(data)
    
    //id=host&name=message&data=message
    a.writeln('POST /postall HTTP/1.1')
    a.writeln('Content-type: application/x-www-form-urlencoded')
    a.writeln('Content-length: ',p.length)
    a.writeln()
    a.write(p)
    
    let s = a.readln()
    //writeln(s)
    if (s.indexOf('200 OK')==-1) throw 'Server error: '+s
    let h = a.readMIME()
    //writeln(h)
    let result = parseInt(a.read(parseInt(h.get('Content-length'))))
    a.close()
    return result    
}

this.decompile=function(fn)
{
 if (typeof fn == "string")
  return {name:"anonymous", params:[], code:fn};
  
 let [,name,params,body] = fn.toString().match(/^function (\w*)\(([^)]*)\) {\n([\s\S]*)\n}$/)
  return {name:name, params: params.split(/,\s*/), code: body} 
}

this.remote=function(fn, data)
{
 if (typeof fn == "string")
  return {name: "evaluate", data: data.map(function(x) ({params:[], code:fn, data:x}).toSource())}

 let [,name,params,body] = fn.toString().match(/^function (\w*)\(([^)]*)\) {\n([\s\S]*)\n}$/)
  return {name:"evaluate", data: data.map(function(x) ({params: params.split(/,\s*/), code: body, data: x}).toSource())} 
}

this.addWorker=function()
{
    let a = new Stream('http://'+this.address+'/start');
    a.readFile();
    a.close();
}

this.jobDone=function(ids)
{
    system.gc()
    let a = new Stream('http://'+this.address+'/done?id=' + ids)
    let r = a.readFile()
    a.close()
    try{
    return r.split(',').map(Number)
    } catch(err) {writeln(r)}
    return null
}

this.resource=function(id)
{    
    return new Stream('http://'+this.address+'/resource?name=' + id);
}

this.jobStatus=function(id)
{    
    let a = new Stream('http://'+this.address+'/history' + (id ? '?id='+id : ''))
    let r = a.readFile()
    a.close()
    try{
    return r.trim().split('\n').map(eval)
    } catch(err) {writeln(r)}
    return null
}

this.exec=function(message,data,host, priority)
{
    let jobid = this.startJob(message,data,host,priority)
    let result = this.jobStatus(jobid)
    while (!result || !result.done)
    {
     system.sleep(20)
     result = jobid.split(',').map(function(id) this.jobStatus(id))
    }
    //writeln(result.toSource())
    return result.map(function(x) x.result)
}

this.startParallel=function(message,data) //data is an array of messages
{
    var grid = this;
    let ret = { jobs : [], result: [], done:0, 
        isDone: function() 
        {
         while (this.done < this.jobs.length)
         {
          let result = grid.jobStatus(this.jobs[this.done])
          if (result && result.time != null) 
          {
           this.result[this.done++] = result.result
          }
          else break          
         }
         if (this.done == this.jobs.length)        
         {
          let a = new Stream('http://'+grid.address+'/flush?id=' + this.jobs.join(','))
          a.readFile()
          a.close()
          return true
         }
         return false
        }
    }
    ret.jobs = this.startJobs(this.address,message,data)

    return ret
}

this.startEvaluate = function(fn, data)
{
    let jobid = this.startSeries([this.remote(fn,data)]);
    if (!jobid) throw "Execution failed: "+jobid;
    return jobid;
}

this.finishEvaluate = function(jobid)
{
    if (!jobid) throw "Invalid job id: "+jobid;
    let result = null;
    
    while (1)
    {
     result = this.jobStatus(jobid);
     //writeln(typeof result.constructor.name)
     
     if (!result) system.sleep(100);
     else
     {
     if (result.done) break;
     else if (result.length && result.every(function(x) {if (typeof x=='undefined') writeln(x.toSource()); return x.done > 0;})) break;
     }
    }
  return(result.map(function(x) eval(x.result)));
}

this.evaluate = function(fn, data)
{
    let jobid = this.startSeries([this.remote(fn,data)]);
    return jobid ? this.finishEvaluate(jobid) : jobid
}

this.parallelExec=function(message,data,quiet, priority)
{
    let jobs = []
    for (let i=0; i<data.length; i++)
    {
     if (i) system.sleep(20)
     jobs.push(this.startJob(message,data[i],null, priority))
    }

    let done = 0;
    while (done < jobs.length)
    {
     let result = this.jobStatus(jobs[done])
     if (result.time != null) 
     {
      jobs[done++] = result.result
      system.sleep(20)
     }
     else 
     {
      if (!quiet) write(done,' ',jobs.length,'\r')
      system.sleep(100)
     }
    }

    return jobs
}
}
