load('grid.js')
load('httpd.js')
//debug = writeln

let port = system.arguments.length ? Number(system.arguments.shift) : 8082

grid = new Grid(port)

let httpd = new HTTPD()
/*
function completionArrayHelper(s,data,x)
{
  return completionCallback(s.job,data,x,s.index)
}

function completionCallback(job, data, x, index) //for single events
{
  if (x) 
  {
    if (job.result && job.result.constructor.name == 'Array')
        job.result[index] = data;
    else
        job.result = data
    job.time = x.time; 
    job.alerts = x.alerts; 
    job.done++
  }
  
  if (job.queue && job.queue.length && (!job.current || job.current.data.length == job.result.length))
  {
    job.current = job.queue.shift()
    if (job.current)
    {
        job.message = job.current.name
        job.data = job.current.data     
        for (let i=0; i<job.current.data.length; i++)
        {
        if (job.done)
          grid.sendToHost(job.host, job.current.name, job.current.data[i], completionArrayHelper, {job:job, index:i})
        else
          grid.postToHost(job.host, job.current.name, job.current.data[i], completionArrayHelper, {job:job, index:i})
        }
        job.result = []     
    }
  }  
  //writeln(data)
}
*/

/*

*/
function completionCallback(job, data,info)
{
 if (info)
 {
    if (job.result && job.result.constructor.name == 'Array' && job.length)
    {
        job.result.push(data);
        if (job.result.length >= job.length) job.done++
    }
    else
    {
        job.result = data
        job.done++
    }
    job.time = info.time; 
    job.alerts = info.alerts; 
    
    if (job.before) //submit jobs that wait on this one
    {
     Job.history.forEach(function(x) 
       {
         let i = x.after.indexOf(job.id);         
         if (i != -1)
         {
          x.after.splice(i,1); 
          if (!x.after.length) 
           x.send(job.grid);          
         }
        })
    }
 } 
}

function Job(message, data, host, after, index) // [ {message: msg, data: [data]}, ... ]
{
 this.message = message
 this.data = data
 this.id = Job.next++
 this.done = 0
 this.result = null
 this.time = null
 this.alerts = null
 this.host = host || null
 this.current = null
 this.before = null
 this.after = after || []
 this.grid = null;
 this.index = index;
 //length = number of copies of execution
 
 Job.history.push(this)
}

Job.next = 1
Job.history = [] //{id: n, message: '', data: '', result: ''}

function findJob(id)
{
 id = Number(id)
 for (let i=0; i<Job.history.length; i++)
  if (Job.history[i].id == id) return i;
 return -1;
}

httpd.index = "grid.html"

/*
grid data
 this.workers = [] // {io, buffer, busy, messages, info, job}
 this.messages = [] // incoming messages from workers (callbacks, perhaps), waiting for processing {source, name, data}
 this.queue = [] // outgoing jobs to workers, waiting to be done {name, data, tries, error}
 this.data = {} // shared binary resources name:stream
 this.files = {} // files shared with workers name:stream
 
*/

function objfields(obj,fields)
{
 let s = ''
 for each (let f in fields)
   if (obj[f]) s += "'" + f + "': " + (obj[f].constructor.name == 'Array' ? obj[f].toSource() : ('"' + obj[f].toString().replace(/\\/g,'\\\\').replace(/\"/g,'\\"').replace(/\s/g,' ') + '"') ) + ','
 return s
}

function respond(client,s,type)
{
    client.writeln("Content-Type: ",type || "text/plain")
    client.writeln("Content-Length: ", s.length)
    client.writeln()
    client.write(s)
}

function validate(client,request,fields)
{
    var t = fields.split(',')
    for each (let f in t)
      if (!request[f])
      {
       respond(client,"ERROR")
       return false      
      }
    return true
}

//intended to be called by AJAX
    
httpd.functions["quit"] = function(client, request, httpd)
    {
        httpd.running = false;
        grid.quit()
        client.writeln("Content-type: text/html");
        client.writeln()
        client.close()
    }

httpd.functions["start"] = function(client,request)
{
    system.execute(system.program, 'gridworker.js '+grid.server.toString()+ ' ' + grid.password);
    writeln("Adding a local worker")
    respond(client,"OK")
    return true
 }

// ?name=functionname&data=a\nb\nc\nd\ne
httpd.functions["postmany"] = function(client,request)
{
    if (!validate(client,request,"name")) return
    
    let params = request.data.split('\n')
    let result = []
    for (let i=0; i<params.length; i++)
    {
        let job = new Job(request.name, params[i], request.host) 
        job.post(grid)        
        result.push(job.id.toString())
    }
    respond(client,result.join(','))
}
    
Job.prototype.post = function(grid)
{
  this.grid = grid;
//writeln('post ',this.message,' ',this.data)
  return grid.postToHost(this.host || 0, this.message, this.data, completionCallback, this)  
}

Job.prototype.send = function(grid)
{
  this.grid = grid;
//writeln('send ',this.message,' ',this.data)
  return grid.sendToHost(this.host || 0, this.message, this.data, completionCallback, this)  
}

// ?name=functionname&data=
httpd.functions["post"] = function(client,request)
{
    if (!validate(client,request,"name")) return
    
    let job = new Job(request.name, request.data, request.host) 
    if (request.priority)
     job.send(grid)
    else
     job.post(grid)
    respond(client,job.id.toString())
}

// ?name=reset&data=parameters
httpd.functions["postall"] = function(client,request)
{
    if (!validate(client,request,"name")) return
    
    let job = new Job(request.name, request.data) 
    job.result = []
    job.length = grid.postToAll(request.name, request.data, completionCallback, job  ) 
    respond(client,job.id)
}

// postseries?series=([{name: "sleep", data: [1,2,3]},[{name: "ping", data: [4,5]}])
httpd.functions["postseries"] = function(client, request)
{
 if (!validate(client,request,"series")) return 
 let group = []
 let batch = []
 let jobs = []
 let ret = []

 try{ 
 let series = eval(request['series']) //list of {name: "", data: [...]}
 for (let i=0; i<series.length; i++)
 {
   jobs.forEach(function(x) x.before=1)
   if (typeof series[i].data == "string")
       series[i].data = [series[i].data]
   for (let j=0; j<series[i].data.length; j++)
   {
    jobs.push(new Job(series[i].name, series[i].data[j], series[i].host, group.concat(), j))
   }
   batch.push(jobs)
   group = jobs.map(function(x) x.id)    
   ret = ret.concat(group)
 }
 
 if (request['priority'])
 {
  if (batch.length) batch[0].forEach(function(x) x.send(grid));
 }
 else
  if (batch.length) batch[0].forEach(function(x) x.post(grid));
  
 respond(client,ret.toString())
 } catch(x)
 {
 writeln(x.toSource())
  respond(client,'')
 }
}

httpd.functions["flush"] = function(client,data)
{
    if (data.host)
    {
     let ids = data.host.split(',')
     for (let j=0; j<ids.length; j++)
     {
         let i = findJob(ids[j])
         //writeln('flush',ids[j],i,Job.history[i])
         if (i == -1)
         {
            respond(client,"ERROR")
            return
         }
         Job.history.splice(i,1)
     }
    }
    else 
     Job.history = []
    
    system.gc()
    respond(client,"OK")
}
// ?id=job_id
httpd.functions["state"] = function(client,data)
{ //workers, queue, history
    let s = []
    for each (let w in grid.workers)
    {
     s.push( '({' + objfields(w, ['id','busy','messages','info','alert']) + ' addr:"' + w.io + '"')
     if (w.job)
      s.push(', job: {' + objfields(w.job, ['status','name','data','tries','error','alerts']) + '}')
     if (w.history)
      s.push(', history: {' + objfields(w.history, ['status','name','data','tries','error','alerts']) + '}')
     s.push( '})\n')
    }
    s.push('----------\n')
    for each (let p in grid.queue)
      s.push('({' + objfields(p, ['worker','name','data','tries','error']) + '})\n')
    s.push('----------\n')
    for (let i=0; i< Job.history.length; i++)
     s.push('({' + objfields(Job.history[i],['message','data','id','done','result','time','alerts','host','current','before','after']) + '})\n')
     
   respond(client,s.join(''))
}

httpd.functions["workers"] = function(client,data)
{
    let s = []
    for each (let w in grid.workers)
    {
     s.push('({' + objfields(w, ['id','busy','messages','info','alert']) + ' addr:"' + w.io + '"')
     if (w.job)
      s.push(', job: {' + objfields(w.job, ['name','data','tries','error','alerts']) + '}')
     s.push('})\n')
    }
    respond(client,s.join(''))
}

httpd.functions["queue"] = function(client,data)
{
    let s = []
    for each (let p in grid.queue)
      s.push('({' + objfields(p, ['worker','name','data','tries','error']) + '})\n')
    respond(client,s.join(''))
}

httpd.functions["errors"] = function(client,data)
{
    let s = []
    while (grid.errors.length)
      s.push('{' + objfields(grid.errors.shift(), ['worker','name','data','tries','error'] ) + '}\n')
    respond(client,s.join(''))
}

httpd.functions["done"] = function(client,data)
{

   let ids = data['id'].split(',').map(Number)
   var l = Job.history.filter(function(x) ids.indexOf(x.id) != -1)
   respond(client,l.map(function(x) x.done?1:0).toString())    
}

httpd.functions["resource"] = function(client,data)
{
    if (data.name)
    {
     if (s = grid.data[data.name])
     if (!s) respond(client,"not found");
     else
     {
      let type = data.name.match(/\.([^.]+)$/);
      let handler = httpd.handlers[type[1]] || "text/plain";
      client.writeln("Content-Type: ");
      client.writeln("Content-Length: ", s.size);
      s.rewind();
      client.writeln();
      client.append(s);
     }
    }
    else
    {
     var s = []
     for (let [n,v] in grid.data)
      s.push('<a href=?name='+escape(n)+'>'+n+'</a> ('+v.size+')');
     respond(client,s.join('<br>'),"text/html");
    }
}

httpd.functions["history"] = function(client,data)
{
    var s = []
    var l = Job.history
    if (data.host)
    {
     let host = parseInt(data.host)
     l = Job.history.filter(function(x) {return x.host == host})
    }
    
    if (data.id)
    {
     let ids = data.id.split(',').map(Number)
    l = l.filter(function(x) {return ids.indexOf(x.id) != -1})    
    }
    for (let i=0; i< l.length; i++)
     s.push('({' + objfields(l[i],['message','data','id','done','result','time','alerts','host','current','before','after']) + '})\n')
    respond(client,s.join(''))
}

httpd.functions["killall"] = function(client,data)
{
    grid.queue = []
    Job.history = []
    Job.queue = []
    
    respond(client,"OK")
}
writeln(grid.server.toString());
system.browse('http://' + grid.server.toString());
grid.run(function(){return !system.kbhit()},httpd);
